#include <graphics.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <math.h>
#include <string.h>
#define PI 3.1415

int Gomb(double &, double &,double &, double &,double &, double &, double &);

void Init()
{
int gdriver = VGA, gmode=VGAHI, errorcode;

initgraph(&gdriver, &gmode, "egavga.bgi");

errorcode = graphresult();

if (errorcode != grOk)
	{
	printf("Graphics error: %s\n", grapherrormsg(errorcode));
	printf("Press any key to halt:");
	getch();
	exit(1);
	}

}


inline double FI(double F)
{
return F-=2*PI*(int)(F/(2*PI));
}



int main(void)
{
double ModSignalAmpl, FreqModSignal, ModSignal;
double SignalAmpl, SignalFreq, Signal, Offset;
double PWMAmpl, VLup, VLdown;
double RadModSignal, RadSignal;
double Lup, Ldown, Cout, Rt;
double ILup, ILdown, Vout, It;
double Resolution, CoilLoss;
double a, Step, t;
char s[30];

Init();

Lup=22*0.000001;
Ldown=22*0.000001;
Cout=350*0.000000001;
Rt=4;

FreqModSignal=384000;
ModSignalAmpl=100;

SignalFreq=20000;
SignalAmpl=90;

PWMAmpl=40;

Offset=0;

Step=0.25;
Resolution=10000;
t=1/Resolution/(640/Step);
CoilLoss=0.0001;

ILup=ILdown=0;
Vout=0;

setcolor(7);
do
	{
	cleardevice();
	line(0,230,640,230);
	line(0,350,640,350);
	for(a=0;a<640;a+=Step)
		{

		RadSignal=((double)(a/((640)/(SignalFreq/Resolution))))*2*PI;

		Signal=SignalAmpl*sin(RadSignal);

/*		if(a<320) Jel=0;
		if(a>=320) Jel=0;
*/
		RadModSignal=((double)(a/((640)/(FreqModSignal/Resolution))))*2*PI;
		RadModSignal=FI(RadModSignal);

		if(RadModSignal < PI/2)
			{
			ModSignal=(RadModSignal/(PI/2))*(ModSignalAmpl);
			}

		else if(RadModSignal < 3*PI/2)
			{
			ModSignal=ModSignalAmpl-((RadModSignal-PI/2)/(PI/2))*ModSignalAmpl;
			}

		else
			{
			ModSignal=-ModSignalAmpl+((RadModSignal-3*PI/2)/(PI/2))*(ModSignalAmpl);
			}

		VLup=(Signal>ModSignal) ? PWMAmpl : -PWMAmpl;
		VLdown=(-Signal>ModSignal) ? -PWMAmpl : PWMAmpl;

		ILup+=((VLup-Vout)/Lup)*t-CoilLoss;
		ILdown+=((Vout-VLdown)/Ldown)*t-CoilLoss;

		if(ILup<0)
			ILup=0;
		if(ILdown<0)
			ILdown=0;

		It=Vout/Rt;

		Vout+=((ILup-ILdown-It)*t)/Cout;


		if(Vout>=PWMAmpl)
			{
			Vout=Vout;
			}

		putpixel(a,50-Signal/2,7);
		putpixel(a,50-ModSignal/2,8);
		putpixel(a,30-VLup/3,14);
		putpixel(a,70-VLdown/3,15);

		putpixel(a,230-ILup*10,10);
		putpixel(a,230-ILdown*10,11);
		putpixel(a,350-Vout*2,9);
		putpixel(a,350-(ILup-ILdown)*10,12);

		}

	}
while(Gomb(Resolution,SignalFreq,SignalAmpl,Lup,Ldown,Cout,Rt));


closegraph();
return 0;
}


int Gomb(double &Resolution,double &SignalFreq,double &SignalAmpl,double &Lup,double &Ldown,double &Cout, double &Rt)
{
char c=getch();

switch(c)
	{
	case 27 : return 0;
	case '9': SignalFreq+=1000; break;
	case '8': SignalFreq-=(SignalFreq>1000) ? 1000 : 0; break;
	case 'i': SignalAmpl+=5; break;
	case 'u': SignalAmpl-=(SignalAmpl>0) ? 5 : 0; break;
	case 'j': Lup+=0.000001;Ldown+=0.000001; break;
	case 'h': Lup-=(Lup>0.000001) ? 0.000001 : 0;
		  Ldown-=(Ldown>0.000001) ? 0.000001 : 0;break;
	case 'n': Cout+=0.000000025; break;
	case 'b': Cout-=(Cout>0.000000025) ? 0.000000025 : 0; break;
	case '6': Resolution/=2; break;
	case '7': Resolution=Resolution*2; break;
	case 't': Rt-=(Rt>1) ? 1 : 0; break;
	case 'z': Rt+=1;
}

return 1;
}
